#include <libhashkit/hashkit.h>
#include <libhashkit/function.h>
#include <ch.h>

typedef uint32_t (*hashkit_hash_fn)(const char *key, size_t key_length, void *context);

static ChInterp_t interp;

///////////////////////////
//hashkit_set_custom_function_chdl
///////////////////////////

static void* hashkit_hash_fn_chdl_funptr;

static uint32_t hashkit_hash_fn_chdl_funarg(const char *key, size_t key_length, void *context)
{
  uint32_t retval;
  Ch_CallFuncByAddr(interp, hashkit_hash_fn_chdl_funptr, &retval, key, key_length, context);
  return retval;
}

EXPORTCH hashkit_return_t hashkit_set_custom_function_chdl(void *varg) {
    //ChInterp_t interp;
    ChVaList_t ap;
    hashkit_st *hash;
    hashkit_hash_fn function_CH, function_C;
    void *context;
    hashkit_return_t retval;

    Ch_VaStart(interp, ap, varg);
    hash = Ch_VaArg(interp, ap, hashkit_st *);

    function_CH = Ch_VaArg(interp, ap, hashkit_hash_fn);
    hashkit_hash_fn_chdl_funptr = (void*)function_CH;
    if (function_CH!=NULL)
      function_C = (hashkit_hash_fn)hashkit_hash_fn_chdl_funarg;
    
    context = Ch_VaArg(interp, ap, void *);
    retval = hashkit_set_custom_function(hash, function_C, context);
    Ch_VaEnd(interp, ap);
    return retval;
}


///////////////////////////
//hashkit_set_custom_distribution_function_chdl
///////////////////////////
EXPORTCH hashkit_return_t hashkit_set_custom_distribution_function_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    hashkit_st *self;
    hashkit_hash_fn function_CH, function_C;
    void *context;
    hashkit_return_t retval;

    Ch_VaStart(interp, ap, varg);
    self = Ch_VaArg(interp, ap, hashkit_st *);
    
    function_CH = Ch_VaArg(interp, ap, hashkit_hash_fn);
    hashkit_hash_fn_chdl_funptr = (void*)function_CH;
    if (function_CH!=NULL)
      function_C = (hashkit_hash_fn)hashkit_hash_fn_chdl_funarg;
    
    context = Ch_VaArg(interp, ap, void *);
    retval = hashkit_set_custom_distribution_function(self, function_C, context);
    Ch_VaEnd(interp, ap);
    return retval;
}